/* Copyright (C) 1997-2004 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; as a special exception the author gives
 * unlimited permission to copy and/or distribute it, with or without 
 * modifications, as long as this notice is preserved.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/* ---------------------------------------------------------------------------- 
  local typemaps 
 */

%{
  #include <hooker.h>
%}

#ifdef OLD_SWIG
%typemap(tcl8, out) TclResultType {
   if($source == TCL_ERROR && hkResult->type != HTError) {
      return TCL_ERROR;
   } else {
      switch(hkResult->type) {
	 case HTNone:
	      break;
	 case HTInt:
	      Tcl_SetIntObj($target, hkResult->data.intResult);
	      break;
	 case HTString:
	      Tcl_SetStringObj($target, hkResult->data.stringResult, -1);
	      break;
	 case HTError:
	      if (hkResult->hook) {
		Tcl_AppendStringsToObj($target, ": error in hook `", 
		  hkResult->hook->name, "' : disabled", (char *)NULL);
	      } else {
		Tcl_AppendStringsToObj($target, hkResult->data.stringResult, 
		  (char *) NULL);
	      }
	      return TCL_ERROR;
	 default:
	      Tcl_AppendStringsToObj($target, 
		  "unknown hkResult ... abording", (char *) NULL);
	      return TCL_ERROR;
	      /*fprintf(stderr, "ERROR: unknown hkResult %d ...abording\n", 
		      hkResult->type);
	       */
      }
   }
}
#else
%typemap(tcl8, out) TclResultType {
  /* tcl8, out int typemap */
  if ($1 != TCL_OK && hkResult->type != HTError) {
    SWIG_fail;
  } else {
    Tcl_Obj *tclResult = $result;
    int tempi;

    switch (hkResult->type) {
      case HTNone:
	break;
      case HTInt:
	Tcl_SetIntObj(tclResult, hkResult->data.intResult);
	break;
      case HTString:
	Tcl_SetStringObj(tclResult, hkResult->data.stringResult, -1);
	break;
     case HTError:
	if (hkResult->hook) {
	  Tcl_AppendStringsToObj(tclResult, ": error in hook `", 
  	    hkResult->hook->name, "' : disabled", (char *)NULL);
	  hkResult->hook->active = FALSE;
	} else {
  	  Tcl_AppendStringsToObj(tclResult, hkResult->data.stringResult, 
	    (char *) NULL);
	}
	SWIG_fail;
      default:
	Tcl_AppendStringsToObj(tclResult, "unknown hkResult ... abording", (char *)NULL);
	fprintf(stderr, "ERROR: unknown hkResult %d ...abording\n", hkResult->type); 
	SWIG_fail;
    }
  }
}
#endif

%include "hook.h";
%include "hooker.h";
