/*
 * File: functions.h
 * Author: Ingo Schroeder
 * Purpose: header file for functions.c
 * Birth: 17/3/97
 *
 * $Id: functions.h,v 1.23 2004/08/09 11:22:49 micha Exp $
 */

#ifndef FUNCTIONS_H
#define FUNCTIONS_H

/* -- INCLUDES ---------------------------------------------------------- */
#include "cdg.h"
#include <blah.h>
#include "constraintnet.h"
#include "lexemgraph.h"
#include "eval.h"

/* -- MACROS ------------------------------------------------------------ */
/* -- TYPE DEFINITIONS -------------------------------------------------- */
typedef struct {
   String functor;
   VTFunction *function;
   Boolean is_context_sensitive;
   String arity;
   String functionName;
   String doc;
} CDGFunctionStruct;
typedef CDGFunctionStruct* CDGFunction;

/* -- FUNCTIONS --------------------------------------------------------- */
extern CDGFunction funcGetFunction(String functor);
extern String funcGetFunctionName(String functor);

/*
 * These functions should not be exported! Fix the compiler.
 */
extern Value funcAbs(List args, Value v, LexemGraph lg, Vector context);
extern Value funcAcoustics(List args, Value v, LexemGraph lg, Vector context);
extern Value funcCat(List args, Value v, LexemGraph lg, Vector context);
extern Value funcDistance(List args, Value v, LexemGraph lg, Vector context);
extern Value funcExp(List args, Value v, LexemGraph lg, Vector context);
extern Value funcLookup(List args, Value v, LexemGraph lg, Vector context);
extern Value funcMatch(List args, Value v, LexemGraph lg, Vector context);
extern Value funcMax(List args, Value v, LexemGraph lg, Vector context);
extern Value funcMin(List args, Value v, LexemGraph lg, Vector context);
extern Value funcPts(List args, Value v, LexemGraph lg, Vector context);
extern Value funcParens(List args, Value v, LexemGraph lg, Vector context);
extern Value funcQuotes(List args, Value v, LexemGraph lg, Vector context);
extern Value funcPhrasequotes(List args, Value v, LexemGraph lg, Vector context);
extern Value funcParent(List args, Value v, LexemGraph lg, Vector context);
extern Value funcHeight(List args, Value v, LexemGraph lg, Vector context);
extern int funcHeightImpl(LexemNode ln, int levelno, LexemGraph lg, Vector context);

/* -- VARIABLES --------------------------------------------------------- */
extern CDGFunctionStruct eval_functions[];

/* ---------------------------------------------------------------------- */
#endif /* don't insert anything after this #endif */
