/* Copyright (C) 1997-2004 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; as a special exception the author gives
 * unlimited permission to copy and/or distribute it, with or without 
 * modifications, as long as this notice is preserved.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $Id: scorematrix.h,v 1.7 2004/09/01 14:03:48 micha Exp $
 */

/**
  * @addtogroup Scorematrix
  * @{
  */

#ifndef SCOREMATRIX_H
#define SCOREMATRIX_H

#include "blah.h"

/* ---------------------------------------------------------------------- */

struct ScoreMatrixStruct;
typedef struct ScoreMatrixStruct *ScoreMatrix; 
  /**< type of matrix structure pointer */

extern Boolean smGetFlag(ScoreMatrix sm, int r, int c);
extern Boolean smSetFlag(ScoreMatrix sm, Boolean f, int r, int c);
extern ScoreMatrix smNew(int r, int c);
extern double smGetScore(ScoreMatrix sm, int r, int c);
extern double smSetScore(ScoreMatrix sm, double d, int r, int c);
extern void smDelete(ScoreMatrix sm);
extern void smSetAllFlags(ScoreMatrix sm, Boolean f);

/* ---------------------------------------------------------------------- */

#endif /* don't insert anything after this #endif */
/** @} */
