/* 
 * Copyright (C) 1997-2004 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; as a special exception the author gives
 * unlimited permission to copy and/or distribute it, with or without 
 * modifications, as long as this notice is preserved.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $Id: skel.c,v 1.9 2004/02/25 14:28:04 micha Exp $ 
 */

/* -------------------------------------------------------------------------
 * @addtogroup Skel Skel - A Skeleton Module
 * @author your name
 * @date date of birth
 *
 *
 * Demonstration of the current @ref CodingStyle "coding style" and blueprint
 * for new modules.
 *
 * This module demonstrates how a module for the @c CDG typically looks like.
 * In addition it serves as a rough demonstration of some of the doxygen 
 * capabilities. See skel.h and skel.c for the sources of this documentation.
 *
 * Note, that most of the documentation of a module should be placed into its
 * implementations file (e.g. skel.c) and only the documentation of 
 * exported data structures (e.g. MyExportedType) and exported macros are left in the 
 * declatrations file (e.g. skel.h). 
 * So avoid rendundant documentation of functions and stuff in both places.
 * @{
 */

/* -- INCLUDES ------------------------------------------------------------- */
#include <cdg.h> 
#include <skel.h> 

/* -- MACROS --------------------------------------------------------------- */

/* -- TYPE DEFINITIONS ----------------------------------------------------- */

/* -------------------------------------------------------------------------
 * short description.
 * long description
 */
typedef struct {
  int memberA;		     /**< description */
  int memberB;		     /**< description */
} MyPrivateTypeStruct;
typedef MyPrivateTypeStruct *MyPrivateType; /**< type definition */

/* -- VARIABLES ------------------------------------------------------------ */

/** short description. long description */
int myExportedVariable; 

/** short description. This variable is private to this module */
static int myPrivateVariable;    

/* -- FUNCTIONS ------------------------------------------------------------ */
static int myPrivateFunction(int a, int b);

/* -- IMPLEMENTATION ------------------------------------------------------- */

/* ------------------------------------------------------------------------- 
 * short description.
 * long description
 * @param a comments on @a a
 * @param b comments on @a b
 * @returns the result
 */
static inline int myPrivateFunction(int a, int b)
{
  return ++myPrivateVariable + a + b;
}

/* ------------------------------------------------------------------------- 
 * short description.
 * long description
 * @param a comments on @a a
 * @param b comments on @a b
 * @returns the result
 */
int myExportedFunction(int a, int b)
{
  int result;

  myExportedVariable++;

  return result;
}

/* ------------------------------------------------------------------------- */
/* -- ENDOFFILE ------------------------------------------------------------ */
/** @} */


