#!/bin/sh

# ---------------------------------------------------------------------- 
# test file for indexer.c
# 
# uses 'indexer' for creating a database out of dbtest.cdg
# and tests the output of 'cdgdbdumper' against a sample file
# 
# requires: 'cdgdbdump' and 'indexer' in cdg/utils
#           'dbtest.cdg' (the sample lexicon file)
#           'dbtest.dump (the sample output file of the dumper)
#
# creates: 'dbtest.db' (the index database for 'dbtest.cdg')
#	   'dbtestrun.dump' (the dump output for 'dbtest.db')
#
# you can add more sample entries to dbtest.cdg but you have to adjust
# 'dbtest.dump' then (use 'cdgdbdumper' and check if the output is 
# correct)
# ---------------------------------------------------------------------- 

# remove existing dbtest.db
if [ -e dbtest.db ]; then
  rm dbtest.db;
fi

# run indexer with test file
@TOPDIR@/utils/indexer dbtest.cdg dbtest.db > /dev/null

# dump it
@TOPDIR@/utils/cdgdbdump dbtest.db > dbtestrun.dump

# diff with sample file
[ "`diff -q dbtestrun.dump dbtest.dump`" == "" ] && exit 0 || exit 1;
