#!/bin/sh
#\
exec tclsh "$0" "$@" 

source loadtclbindings

testCmdEval "set debug on"
testCmdEval "set preprocessor /bin/zcat";
testCmdEval "set prepsuffix .gz";
testCmdEval "load @TESTGRAMMAR@";

putsDebug "inputCurrentGrammar=[inputCurrentGrammar_get]\n" 
putsDebug "getting lexiconItems\n" 
set lexiconItems [InputStruct_lexicon_get [inputCurrentGrammar_get]];
if {$lexiconItems == 0 || $lexiconItems == "NULL"} {
  error "ERROR: lexiconItems=$lexiconItems"
}

putsDebug "hashIteratorNew\n"
set hi [hashIteratorNew $lexiconItems]; 

putsDebug "hashSize\n" 
set size [hashSize $lexiconItems];

if {$size <= 0} {
  error "ERROR: no lexicon found" 
}
putsDebug "size=$size\n"

set noEntries 0;
set noForms 0;
for {set forms [hashIteratorNextValue $hi]} {$forms != "NULL"} \
    {set forms [hashIteratorNextValue $hi]} {
  putsDebug "listElement forms=$forms\n"
  set item [listElement $forms]
  putsDebug "DEBUG: LexiconItemStruct_word_get item=$item\n"
  set word [LexiconItemStruct_word_get $item];
  putsDebug "$word = " 

  for {set l $forms} {$l != "NULL"} {set l [listNext $l]} {
    set entry [listElement $l];
    set id [LexiconItemStruct_description_get $entry];
    putsDebug "$id "
    incr noForms;
  }
  putsDebug "\n"
  incr noEntries;
}
cdgFinalize;
putsDebug "INFO: counted $noEntries lexicon entries with overall $noForms word forms\n"

if {$size != $noEntries} {
 error "ERROR: hash size is $size, but only counted $noEntries lexical entries"
}

