/* Copyright (C) 1997-2003 The BLAH Team <blah@nats.informatik.uni-hamburg.de>
 *
 * This file is free software; as a special exception the author gives
 * unlimited permission to copy and/or distribute it, with or without
 * modifications, as long as this notice is preserved.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <blah.h>

int main(int argc, char **argv)
{
  long first, prime, times;
  int i, n;

  blahInitialize();

  if (argc != 4) {
    first = prime = 10;
    times = 15;
    n = 20;
  } else {
    first = prime = atol(argv[1]);
    times = atol(argv[2]);
    n = atoi(argv[3]);
  }

  /* Checking for prime > 1 */
  if (prime < 1) {
    exit(1);
  }

  /* Testing PrimeNext */
  for (i = 0; i < n; i++) {
    prime = primeNext(prime, times);
    prime++;
  }				       
  
#if 0
  printf("density=%f%%\n", ((float)n / (float)(prime - first)) * 100);/
#endif

  blahFinalize();
  return 0;
}

