#!/usr/bin/env perl

# pod2latex conversion program

use Pod::LaTeX;
use Getopt::Long;

my @sections;

GetOptions(
  "sections=s@" => \@sections,
);

my $parser = new Pod::LaTeX(
  AddPostamble => 0,
  AddPreamble => 0,
  Head1Level => 1,
  LevelNoNum => 4,
  MakeIndex => 1,
  ReplaceNAMEwithSection => 0,
  StartWithNewPage => 0,
  TableOfContents => 1,
  UniqueLabels => 1,
);

$parser->select(@sections) if @sections;

if (@ARGV == 0) {
  $parser->parse_from_filehandle(\*STDIN);
} else {
  foreach (@ARGV) { 
    $parser->parse_from_file($_); 
  }
}


